/****************************************************************************
  FILE: TangoClient.java, TomaszMajor-07May98, mc-v0.00-12Feb97
****************************************************************************/


package webwisdom.tango;


/**Java interface for Tango applications.
   TangoClient should create its own TangoAgent
   as an intermediary with the Tango system.
 *@author Tomasz Major
 *@see TangoAgent*/
public interface TangoClient
{


    /**Receives data from the same session.
       Should be implemented in order to get any usueful collaboration.
       *@param bytes exchanged data*/
    public void receive(byte[] bytes);
    // receive _____________________________________________________________


    /**Receives data from different session. Should be implemented
       if application expects exchange with applications of different types.
       *@param appName application originating exchange
       *@param bytes exchanged data*/
    public void crossReceive(String appName,byte[] bytes);
    // crossReceive ________________________________________________________


    /**Receives control data from the Tango system.
       *@param type type of control message
       *@param message content of control message*/
    public void controlReceive(int type,TangoCtrMsg message);
    // controlReceive ______________________________________________________


}// TangoClient ////////////////////////////////////////////////////////////


