/****************************************************************************
  FILE: TangoCtrMsg.java, TomaszMajor-07May98, mc-v0.00-12Feb97
****************************************************************************/


package webwisdom.tango;


/**Generic control message sent from TangoAgent to TangoClient.
 *@author Tomasz Major
 *@see TangoClient*/
public abstract class TangoCtrMsg
{
    private static final String CL="TangoCtrMsg";


    public static final int UNDEFINED=-1;
    public static final int SYSTEM_DOWN=1;


    protected int type=UNDEFINED;


    public String typeToString(int t)
    {
      switch(t)
      {
	case SYSTEM_DOWN:
	  return "SYSTEM_DOWN";
	default:
	  return "UNDEFINED";
      }
    }// typeToString _______________________________________________________


    public String toString()
    {
      return CL+"["+typeToString(type)+"]";
    }// toString ___________________________________________________________


}// TangoCtrMsg ////////////////////////////////////////////////////////////


