package webwisdom.tango.beans;

import java.beans.*;
import java.awt.event.*;

/*
**    BeanInfo for JavaBean:
*/
public class ObjectPipeBeanInfo extends SimpleBeanInfo
{

    // getIcon returns an image object which can be used by toolboxes, toolbars
    // to represent this bean. Icon images are in GIF format.
    public java.awt.Image getIcon(int iconKind)
    {
        if (iconKind == BeanInfo.ICON_COLOR_16x16 ||
            iconKind == BeanInfo.ICON_MONO_16x16)
        {
            java.awt.Image img = loadImage("JavaBeanIcon16.gif");
            return img;
        }
        if (iconKind == BeanInfo.ICON_COLOR_32x32 ||
            iconKind == BeanInfo.ICON_MONO_32x32)
        {
            java.awt.Image img = loadImage("JavaBeanIcon32.gif");
            return img;
        }
        return null;
    }
        
     public MethodDescriptor[] getMethodDescriptors() {
     
        Class parameters[] = new Class[1];
        
        parameters[0] = Object.class;
        
        try {
        
            MethodDescriptor sendDataMethod = new MethodDescriptor(ObjectPipe.class.getMethod("sendData", parameters));
            sendDataMethod.setDisplayName("Send Data");
            MethodDescriptor rv[] = {sendDataMethod};
            return rv;
        } catch(NoSuchMethodException e) {
         
            throw new Error(e.toString());            
        }
       
        
        
    }

    // getPropertyDescriptors returns an array of PropertyDescriptors which describe
    // the editable properties of this bean.

       public PropertyDescriptor[] getPropertyDescriptors()
    {
                     
        PropertyDescriptor rv[] = {};
        return rv;
        
    }


    public EventSetDescriptor[] getEventSetDescriptors() {

              try
        {
            EventSetDescriptor dataArrived = new EventSetDescriptor(beanClass, "event1", dataListenerClass, "dataArrived");            
            dataArrived.setDisplayName("Data Arrived");            
            EventSetDescriptor connectPipe = new EventSetDescriptor(beanClass, "event2", connectListenerClass, "pipeReady");            
            connectPipe.setDisplayName("Pipe Ready to Connect");
            EventSetDescriptor rv[] = {dataArrived, connectPipe};
            return rv;
        }
        catch (IntrospectionException e)
        {
            throw new Error(e.toString());
        }
    }




    private final static Class beanClass = ObjectPipe.class;
    private final static Class dataListenerClass = PipeDataListener.class;
    private final static Class connectListenerClass = PipeConnectListener.class;
}