
package webwisdom.tango.beans;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.applet.*;


public abstract class Pipe extends Component implements java.io.Serializable
{
	public Pipe()
	{
		super();
		setSize(40,40);

		if (Beans.isDesignTime()) {
		    setVisible(true);
		} else {
		    setVisible(false);		 
		}
	}

	public void paint(Graphics context)
	{
		context.setColor(componentColor);
		context.fill3DRect(0,0,getSize().width,getSize().height, true);
		context.setColor(textColor);
		context.drawString("Tango", 5, 25);
		context.setColor(componentColor);
	}

	public synchronized Color getComponentColor()
	{
		return componentColor;
	}

	public void setComponentColor (Color newColor)
	{
		componentColor = newColor;
		repaint();
	}

	
    public synchronized void addPipeConnectListener(PipeConnectListener tel) {
    
        PipeConnectEvent cre = new PipeConnectEvent(this);
        tel.pipeReady(cre); 
    }

    public synchronized void removePipeConnectListener(PipeConnectListener tel) {

    }
    
    public synchronized void setControl(int id, TangoBean c) {
           
        ctr = c;
        pipeID = id;
    }
    
    public void sendDataAsObject(Object toTango) {
        
        if (ctr != null) {
        
            ctr.sendToTango(pipeID, toTango);   
            
        } else {
            
            System.out.println("Pipe: pipe not connected to TangoBean");   
        }
        
    }

    public abstract void receiveData(Object fromTango);

	protected Color componentColor = Color.blue;
	protected Color textColor = Color.black;
	private TangoBean ctr;
	private int pipeID;

}