/*
File: ControlAppThreadIn.java
Date		Author		Changes
Sep 09 96	Lukasz Beca	Created
14May98         TomaszMajor     plugin on the same page, AppletBase register
*/


package webwisdom.tango.interfaces;

import java.applet.Applet;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.LocalBase;
import webwisdom.tango.structures.ControlApplication;
import netscape.javascript.JSObject;
import webwisdom.tango.consts.Const;

public abstract class ControlAppletBase extends Applet
{
    private static final String CL="ControlAppletBase";


    private ControlApplication ca=null;
  

    public int register()
    {
      System.out.println(CL+".register()");
      LocalBase localBase=LocalBase.getLocalBase();
      if(localBase==null)
      {
	System.err.println(CL+".register(): plugin not found!");
	destroy();
	return Const.OK;
      }
      ca=localBase.reg.registerCA(this);
      if(ca==null)
	throw new Error("null ca");
      System.out.println(CL+".register(): ok");
      return ca.getStatus();    
    }// register ___________________________________________________________


    public void sendServer(Message m)
    {    
      ca.sendCABToCS(m);
    }


    public void sendApp(int AID,Message m)
    {
      ca.sendCABToApp(AID,m);
    }


    public void finish(int AID)
    {
      ca.finish(AID);  
    }


    public void logout()
    {
      ca.logout();
    }

  
    public String getServer()
    {
      return ca.getServerHost();
    }


    public boolean appExists(int AID)
    {
      return ca.appExists(AID);
    }
    

    public void startApplet(String url,int AID,int SID,int AT,
			    String height,String width)
    {
      ca.startApplet(url,AID,SID,AT,height,width); 
    }
	

//     public void startApplet(String url,int AID,int SID,int AT,
// 			    String framename)
//     {
//     }


    public void startApplication(int AID, int SID, int AT)
    {
      String path = getApplicationPath(AT);
      ca.startApplication(path, AID, SID, AT);
    }


    public synchronized abstract void receiveServer(Message m);


    public synchronized abstract void receiveApp(int AID,Message m);
  

    public synchronized abstract void addApplication(int AID,int SID,int AT);
  

    public abstract String getApplicationPath(int AT);


    public abstract void removeApplication(int AID);


    public synchronized abstract void error(int errorCode);


    public void setFocus(int AID)
    {
      ca.setFocus(AID);   
    }


//     /**Finds plugin (of the type LocalBase) with the given name
//        at the same page as the given applet.*/
//     private static LocalBase getPlugin(Applet applet,String pluginName)
//     {
//       JSObject win=(JSObject)JSObject.getWindow(applet);
//       if(win==null)
//       {
// 	System.out.println(CL+".getPlugin(): unable to get reference to \'window\'!");	
// 	return null;
//       }

//       JSObject document=(JSObject)win.getMember("document");
//       if(document==null)
//       {
// 	System.out.println(CL+".getPlugin(): unable to get reference to \'document\'!");
// 	return null;
//       }

//       Object local=document.getMember(pluginName);
//       if(local==null)
//       {
// 	System.out.println(CL+".getPlugin(): unable to get reference to \'"+pluginName+"\'!");
// 	return null;
//       }

//       LocalBase localBase;
//       try
//       {
// 	localBase=(LocalBase)local;
//       }
//       catch(ClassCastException e)
//       {
// 	System.out.println(CL+".getPlugin(): member \'"+pluginName+"\' not a LocalBase!");
// 	return null;
//       }

//       return localBase;
//     }// getPlugin __________________________________________________________


    public String toString()
    {
      return CL;
    }// toString ___________________________________________________________


}// ControlAppletBase //////////////////////////////////////////////////////

