/*
File: LoginMessage.java
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created
*/

package webwisdom.tango.messages;

import webwisdom.tango.messages.Message;
import webwisdom.tango.consts.Const;
import java.io.*;


/**
 * A class representing LOGIN message 
 * 
 *@author Lukasz Beca
 *@see Central Server - Local Demon protocol
 **/

public class LoginMessage extends Message {
  
  private String username;
  private String passwd;

 /**
   *Creates a new LOGIN message
   *@param usernameparam username
   *@param passwdparam password
   **/

  public LoginMessage(String usernameparam, String passwdparam) {

   username = new String(usernameparam);
   passwd = new String(passwdparam);
   type = Const.LOGIN;
  }

/**
   * Creates a new LOGIN message, information is read from the input stream
   *@param instream  input stream
   **/

  LoginMessage(DataInputStream instream) throws IOException {
    

    
    username = instream.readUTF();
    passwd = instream.readUTF();

    type = Const.LOGIN;
    
  }

/**
   * Writes LOGIN message to the output stream
   *@param outstream  output stream
   **/

  void send(DataOutputStream outstream) throws IOException {
     
    //System.out.println("Sending type " + Const.LOGIN);
    outstream.writeInt(Const.LOGIN);
    //System.out.println("Sending username " + username);
    outstream.writeUTF(username);
    //System.out.println("Sending passwd " + passwd);
    outstream.writeUTF(passwd);
    outstream.flush();

  }

  /**
   * Returns user name
   **/ 

  public String getUsername() {
    
    String result = new String(username);

    return result;

  }  

 /**
   * Returns user password
   **/  

  public String getPasswd() {

    String result= new String(passwd);

    return result;
  }

}
