/*
File: LocalBase.java
Date		Author		Changes
Mar 07 97	Lukasz Beca	Created
*/
 
package webwisdom.tango.structures;

import webwisdom.tango.consts.Const;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.CentralServer;
import webwisdom.tango.structures.ControlApplication;
import webwisdom.tango.structures.Registrar;
import netscape.plugin.Plugin;
import webwisdom.tango.structures.ScriptHandle;
import netscape.javascript.JSObject;
import netscape.security.PrivilegeManager;

public class LocalBase extends Plugin
{
    private static final String CL="LocalBase";


    private String serverHost;
    private int serverPort,localPort;

    private ControlApplication ca;
    public Registrar reg;


    private static LocalBase localBase=null;


    public LocalBase()
    {
      serverHost=new String(getServerHost());
      if(serverHost==null)
	throw new Error("serverHost=null");
      if(serverHost.equals("*"))
	throw new Error("serverHost=\"*\" (invalid)");

      serverPort=getServerPort();
      if(serverPort==-1)
	throw new Error("serverPort=-1");

      localPort=getLocalPort();
      if(localPort==-1)
	throw new Error("localPort=-1");

      System.out.println(CL+".LocalBase(): server="+serverHost+
			 ":"+serverPort+" localPort="+localPort);


      ca=new ControlApplication();
      reg=new Registrar(localPort);
      System.out.println(CL+".LocalBase(): ca="+ca+" reg="+reg);

      localBase=this;
    }// LocalBase __________________________________________________________
  

    public static LocalBase getLocalBase()
    {
      return localBase;
    }// getLocalBase _______________________________________________________
  

    public void init()
    {
      System.out.println(CL+".init()");
      PrivilegeManager.enablePrivilege("30Capabilities");
    
      CentralServer cs=new CentralServer(serverHost,serverPort);
      LocalApplications apps=new LocalApplications();   
      reg.initAssociations(ca,apps);
      ca.initAssociations(this,cs,apps,reg);
      cs.initAssociations(ca,apps);
      apps.initAssociations(ca,cs);
      System.out.println(CL+".init(): end");
    }// init _______________________________________________________________

    
    public void destroy()
    {
      System.out.println(CL+".destroy()");
      ca.terminated();
      ca=null;
      reg=null;
    }// destroy ____________________________________________________________


    /**interface for ControlApplication*/
    public synchronized void startApplication(String path,
					      int AID,int SID,int AT,
					      int localport)
    {
      runApplication(path,AID,SID,AT,localport);
    }// startApplication ___________________________________________________


    /**interface for scripts*/
    public ScriptHandle addScript(JSObject window,
				  String AIDs,String SIDs,String ATs)
    {
      return reg.registerScript(window, AIDs, SIDs, ATs);
    }// addScript __________________________________________________________
   

    private native int runApplication(String path,
				      int AID,int SID,int AT,
				      int port);
    // runApplication ______________________________________________________
   

    /**
     *@return "*" if not available*/
    private native String getServerHost();
    // getServerHost _______________________________________________________


    /**
     *@return -1 if not available*/
    private native int getServerPort();
    // getServerPort _______________________________________________________


    /**
     *@return -1 if not available*/
    private native int getLocalPort();
    // getLocalPort ________________________________________________________
  

}// LocalBase //////////////////////////////////////////////////////////////










