/*
File: AppThreadIn.java
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.threads;

import java.lang.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.messages.AppNet;
import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.consts.Const;
import webwisdom.tango.protocols.ApplicationProtocol;
import webwisdom.tango.threads.AppThreadOut;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.Registrar;
import webwisdom.tango.structures.ApplicationHandle;

public class AppThreadIn extends ApplicationProtocol implements Runnable {

  
  private AppNet n;
  private AppThreadOut out;
  private Thread th;   //reference to this thread 
  private boolean exit;
  private Registrar reg;
 
  public AppThreadIn(Socket s, AppThreadOut outpar, LocalApplications localpar, Registrar regpar) {
    
    super(localpar);
    out = outpar;   
    n = new AppNet(s);   
    th = new Thread(this);
    exit = false;
    th.start();
    reg = regpar;
  }

 
  
  public void run() {

    AppEventMessage m;
    int AIDtmp, SIDtmp, ATtmp;
    ApplicationHandle apph;
    int i, j;

 //   System.out.println("AppThreadIn: Application input thread started");
    
    AIDtmp = n.getData();
    SIDtmp = n.getData();
    ATtmp = n.getData();

    initAID(AIDtmp);
    
    apph = reg.registerApplication( this, out, AIDtmp, SIDtmp, ATtmp);

 //   System.out.println("AppThreadIn: Application registered with AID " + AIDtmp + " SID " + SIDtmp + " AT " + ATtmp);
    
    while(!exit) {


      try {
	m = n.receive();
      } catch(IOException e) {

	m = null;
	
//	System.out.println("AppThreadIn Err: " + e);
	e.printStackTrace();
	System.out.println("AppThreadIn: removing application from demon structures");
	lapps.terminated(AID);	
//	System.out.println("AppThreadIn: trying to shut down connection and terminate threads");

	stop();
	break;

      }
	     
      if (m != null) {

	handleAPPEVENT(m);

     
      }
      else {
	System.out.println("AppThreadIn: Error: invalid message received");
      }	
	
    }

  }

  public void stop() {

  //  System.out.println("AppThreadIn: Application ended - threadin ended");
    
    exit = true;

    out.stop();

    n.close();

  }

}
