/*
File: AppThreadOut.java
Date		Author		Changes
Sept 06 96	Lukasz Beca	Created
*/

package webwisdom.tango.threads;

import java.lang.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.messages.AppNet;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.MessageQueue;




public class AppThreadOut implements Runnable {

  private MessageQueue q;
  private AppNet n;
  private Thread th;
  static int number = 1;    //for testing only
  int thisno;  //for testing only
  private boolean exit;

  public AppThreadOut(Socket s) {

    super();    
    n = new AppNet(s);
    q = new MessageQueue();
    th = new Thread(this);
    thisno = number;
    number ++;
    exit = false;
    th.start();
   

  }

  public void run() {

    Message m;
   
 //   System.out.println("AppThreadOut: Output thread number " + thisno + " started");
   
    
    while(!exit) {

//	System.out.println("AppThreadOut: Thread number " + thisno + " sending");
	m = q.getMessage();
	
	try {
	  n.send(m);
	} catch(IOException e) {
	  
	  System.out.println("AppThreadOut: problems with sending messages " + e);
	  e.printStackTrace();

	}

      
    }

  }

  public synchronized void putMessage(Message m) {

    q.putMessage(m);
   
  }

 
  public void stop() {

 //   System.out.println("AppThreadOut: thread ended");

    exit = true;
    q.unblock();

  }
}
