/*
File: DemonThreadIn.java
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.threads;

import java.lang.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.messages.Net;
import webwisdom.tango.messages.Message;
import webwisdom.tango.threads.ThreadOut;
import webwisdom.tango.consts.Const;
import webwisdom.tango.protocols.DemonProtocol;
import webwisdom.tango.structures.CentralServer;


public class DemonThreadIn extends DemonProtocol implements Runnable {
  
  private Thread th;   //reference to this thread 
  private boolean exit;
  private Net n;

  public DemonThreadIn(ThreadOut outparam, Socket s, CentralServer cspar) {
	   
    super(outparam, cspar);     
    n = new Net(s);   
    th = new Thread(this);
    exit = false;
    th.start();
  }
  
  public void run() {

    Message m;
    int type;
       
 //   System.out.println("DemonThreadIn: Demon input thread started");
  
    while(!exit) {


      try {
	m = n.receive();
      } catch(IOException e) {	

	e.printStackTrace();
	m = null;
	System.out.println("DemonThreadIn: connection closed");
	cs.connectionBrk();
	break;

      }
	     
      if (m != null) {

      type = m.getType();

      if (type == Const.EVENT) 
	
	handleEVENT(m);

      else {


	switch(type) {

	  case Const.COMMAND:
	   handleCOMMAND(m);
	   break;

          case Const.RASK:
	   handleRASK(m);
	   break;
	   
          case Const.SUPD:
	   handleSUPD(m);
	   break;

          case Const.MASK:
	   handleMASK(m);
	   break;
	   
          case Const.LOGACC:
	   handleLOGACC(m);
	   break;

	  case Const.JASK:
	   handleJASK(m);
	   break;

          case Const.JANS:
	   handleJANS(m);
	   break;
	  
          case Const.RANS:
	   handleRANS(m);
	   break;

          case Const.MANS:
	   handleMANS(m);
	   break;
	   
	   				 case Const.PING:
					 
		 handlePING(m);
	   break;
	    
          default:
	   System.out.println("DemonThreadIn: command not implemented");
	}

      }      
     
    }
      else {
	System.out.println("DemonThreadIn: invalid message received");
      }	
	
  }

  n.close();
//  System.out.println("DemonThreadIn: thread ended");

  }

  public void stop() {

//    System.out.println("DemonThreadIn: stop called");
    exit = true;
    
  }


}





