/*
File: ThreadOut.java
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/

package webwisdom.tango.threads;

import java.lang.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.messages.Net;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.MessageQueue;



public class ThreadOut implements Runnable {

  private MessageQueue q;
  private Net n;
  private Thread th;
  static int number = 1;    //for testing only
  int thisno;  //for testing only
  private boolean exit;

  public ThreadOut(Socket s) {

    super();    
    n = new Net(s);
    q = new MessageQueue();
    th = new Thread(this);
    thisno = number;
    number ++;
    exit = false;
    th.start();
   

  }

  public void run() {

    Message m;
   
 //   System.out.println("ThreadOut: Output thread number " + thisno + " started");
   
    
    while(!exit) {

      //System.out.println("ThreadOut: Thread number " + thisno + " sending");
	m = q.getMessage();
	
	try {
	  n.send(m);
	} catch(IOException e) {
	  
	  System.out.println("ThreadOut: problems with sending messages " + e);
	e.printStackTrace();
	}	
	
      
    }
    System.out.println("ThreadOut: thread stopped");
  }

  public synchronized void putMessage(Message m) {

    q.putMessage(m);
   
  }

 
  public synchronized void stop() {
          
    System.out.println("ThreadOut: stop called");
    System.out.flush();
   
    exit = true;
    q.unblock();
   
  }
}






      

